/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : February, 1997                                                 */
/* File Name : XtrapMF.h                                                 */
/*************************************************************************/
/*************************************************************************/

#ifndef _XTRAPMF_H
#define _XTRAPMF_H

#include "trapMF.h"

class XtrapMF : public trapMF
{
   public:

     virtual float getValue(float);
     virtual Function* getMyTwin();

     XtrapMF(float,float,float,float);

     friend ostream& operator<<(ostream&, const XtrapMF& );

     virtual void printOn(ostream&) const;

}; // end of class XtrapMF

XtrapMF::XtrapMF(float a1,float a2,float a3,float a4) : trapMF(a1,a2,a3,a4) {}

float XtrapMF::getValue(float x) { return (x*trapMF::getValue(x)); }

Function * XtrapMF::getMyTwin()
{  XtrapMF *ret = new XtrapMF(getLeftBorder(),getLeftTop(),
			      getRightTop(),getRightBorder());
   (*ret).setCutOff(getCutOff());
   return ret;

}// end of getMyTwin()

ostream& operator<<(ostream& os, const XtrapMF& RHS)
{  RHS.printOn(os);
   return os;
}// end of operator<<

void XtrapMF::printOn(ostream& os) const 
{  os << " XTrapezoid(" << Left << "," << LeftTop;
   os << "," << RightTop << "," << Right << ") with " << cutOff;
}// end of printOn()

#endif
